"use strict";Object.defineProperty(exports,"__esModule",{value:!0}),Object.defineProperty(exports,"Lexer",{enumerable:!0,get:function(){return _N3Lexer.default}}),Object.defineProperty(exports,"Parser",{enumerable:!0,get:function(){return _N3Parser.default}}),Object.defineProperty(exports,"Writer",{enumerable:!0,get:function(){return _N3Writer.default}}),Object.defineProperty(exports,"Store",{enumerable:!0,get:function(){return _N3Store.default}}),Object.defineProperty(exports,"StreamParser",{enumerable:!0,get:function(){return _N3StreamParser.default}}),Object.defineProperty(exports,"StreamWriter",{enumerable:!0,get:function(){return _N3StreamWriter.default}}),Object.defineProperty(exports,"DataFactory",{enumerable:!0,get:function(){return _N3DataFactory.default}}),Object.defineProperty(exports,"Term",{enumerable:!0,get:function(){return _N3DataFactory.Term}}),Object.defineProperty(exports,"NamedNode",{enumerable:!0,get:function(){return _N3DataFactory.NamedNode}}),Object.defineProperty(exports,"Literal",{enumerable:!0,get:function(){return _N3DataFactory.Literal}}),Object.defineProperty(exports,"BlankNode",{enumerable:!0,get:function(){return _N3DataFactory.BlankNode}}),Object.defineProperty(exports,"Variable",{enumerable:!0,get:function(){return _N3DataFactory.Variable}}),Object.defineProperty(exports,"DefaultGraph",{enumerable:!0,get:function(){return _N3DataFactory.DefaultGraph}}),Object.defineProperty(exports,"Quad",{enumerable:!0,get:function(){return _N3DataFactory.Quad}}),Object.defineProperty(exports,"Triple",{enumerable:!0,get:function(){return _N3DataFactory.Triple}}),Object.defineProperty(exports,"termFromId",{enumerable:!0,get:function(){return _N3DataFactory.termFromId}}),Object.defineProperty(exports,"termToId",{enumerable:!0,get:function(){return _N3DataFactory.termToId}}),exports.Util=void 0;var _N3Lexer=_interopRequireDefault(require("./N3Lexer")),_N3Parser=_interopRequireDefault(require("./N3Parser")),_N3Writer=_interopRequireDefault(require("./N3Writer")),_N3Store=_interopRequireDefault(require("./N3Store")),_N3StreamParser=_interopRequireDefault(require("./N3StreamParser")),_N3StreamWriter=_interopRequireDefault(require("./N3StreamWriter")),Util=_interopRequireWildcard(require("./N3Util"));exports.Util=Util;var _N3DataFactory=_interopRequireWildcard(require("./N3DataFactory"));function _getRequireWildcardCache(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return _getRequireWildcardCache=function(){return e},e}function _interopRequireWildcard(e){if(e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache();if(t&&t.has(e))return t.get(e);var r,i,s={},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(r in e)Object.prototype.hasOwnProperty.call(e,r)&&((i=a?Object.getOwnPropertyDescriptor(e,r):null)&&(i.get||i.set)?Object.defineProperty(s,r,i):s[r]=e[r]);return s.default=e,t&&t.set(e,s),s}function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;const RDF="http://www.w3.org/1999/02/22-rdf-syntax-ns#",XSD="http://www.w3.org/2001/XMLSchema#",SWAP="http://www.w3.org/2000/10/swap/";var _default={xsd:{decimal:XSD+"decimal",boolean:XSD+"boolean",double:XSD+"double",integer:XSD+"integer",string:XSD+"string"},rdf:{type:RDF+"type",nil:RDF+"nil",first:RDF+"first",rest:RDF+"rest",langString:RDF+"langString"},owl:{sameAs:"http://www.w3.org/2002/07/owl#sameAs"},r:{forSome:SWAP+"reify#forSome",forAll:SWAP+"reify#forAll"},log:{implies:SWAP+"log#implies"}};exports.default=_default,Object.defineProperty(exports,"__esModule",{value:!0}),exports.termFromId=termFromId,exports.termToId=termToId,exports.escapeQuotes=escapeQuotes,exports.unescapeQuotes=unescapeQuotes,exports.Triple=exports.Quad=exports.DefaultGraph=exports.Variable=exports.BlankNode=exports.Literal=exports.NamedNode=exports.Term=exports.default=void 0;var _IRIs=_interopRequireDefault(require("./IRIs")),_N3Util=require("./N3Util");function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const{rdf,xsd}=_IRIs.default;let DEFAULTGRAPH,_blankNodeCounter=0;const escapedLiteral=/^"(.*".*)(?="[^"]*$)/,quadId=/^<<("(?:""|[^"])*"[^ ]*|[^ ]+) ("(?:""|[^"])*"[^ ]*|[^ ]+) ("(?:""|[^"])*"[^ ]*|[^ ]+) ?("(?:""|[^"])*"[^ ]*|[^ ]+)?>>$/,DataFactory={namedNode:namedNode,blankNode:blankNode,variable:variable,literal:literal,defaultGraph:defaultGraph,quad:quad,triple:quad};_default=DataFactory;exports.default=_default;class Term{constructor(e){this.id=e}get value(){return this.id}get hashCode(){return 0}equals(e){return e instanceof Term?this.id===e.id:!!e&&this.termType===e.termType&&this.value===e.value}toJSON(){return{termType:this.termType,value:this.value}}}exports.Term=Term;class NamedNode extends Term{get termType(){return"NamedNode"}}exports.NamedNode=NamedNode;class Literal extends Term{get termType(){return"Literal"}get value(){return this.id.substring(1,this.id.lastIndexOf('"'))}get language(){const e=this.id;let t=e.lastIndexOf('"')+1;return t<e.length&&"@"===e[t++]?e.substr(t).toLowerCase():""}get datatype(){return new NamedNode(this.datatypeString)}get datatypeString(){const e=this.id,t=e.lastIndexOf('"')+1;var r=t<e.length?e[t]:"";return"^"===r?e.substr(t+2):"@"!==r?xsd.string:rdf.langString}equals(e){return e instanceof Literal?this.id===e.id:!!e&&!!e.datatype&&this.termType===e.termType&&this.value===e.value&&this.language===e.language&&this.datatype.value===e.datatype.value}toJSON(){return{termType:this.termType,value:this.value,language:this.language,datatype:{termType:"NamedNode",value:this.datatypeString}}}}exports.Literal=Literal;class BlankNode extends Term{constructor(e){super("_:"+e)}get termType(){return"BlankNode"}get value(){return this.id.substr(2)}}exports.BlankNode=BlankNode;class Variable extends Term{constructor(e){super("?"+e)}get termType(){return"Variable"}get value(){return this.id.substr(1)}}exports.Variable=Variable;class DefaultGraph extends Term{constructor(){return super(""),DEFAULTGRAPH||this}get termType(){return"DefaultGraph"}equals(e){return this===e||!!e&&this.termType===e.termType}}function termFromId(e,t){if(t=t||DataFactory,!e)return t.defaultGraph();switch(e[0]){case"?":return t.variable(e.substr(1));case"_":return t.blankNode(e.substr(2));case'"':if(t===DataFactory)return new Literal(e);if('"'===e[e.length-1])return t.literal(e.substr(1,e.length-2));var r=e.lastIndexOf('"',e.length-1);return t.literal(e.substr(1,r-1),"@"===e[r+1]?e.substr(r+2):t.namedNode(e.substr(r+3)));case"<":r=quadId.exec(e);return t.quad(termFromId(unescapeQuotes(r[1]),t),termFromId(unescapeQuotes(r[2]),t),termFromId(unescapeQuotes(r[3]),t),r[4]&&termFromId(unescapeQuotes(r[4]),t));default:return t.namedNode(e)}}function termToId(e){if("string"==typeof e)return e;if(e instanceof Term&&"Quad"!==e.termType)return e.id;if(!e)return DEFAULTGRAPH.id;switch(e.termType){case"NamedNode":return e.value;case"BlankNode":return"_:"+e.value;case"Variable":return"?"+e.value;case"DefaultGraph":return"";case"Literal":return`"${e.value}"`+(e.language?"@"+e.language:e.datatype&&e.datatype.value!==xsd.string?"^^"+e.datatype.value:"");case"Quad":return`<<${escapeQuotes(termToId(e.subject))} ${escapeQuotes(termToId(e.predicate))} ${escapeQuotes(termToId(e.object))}${(0,_N3Util.isDefaultGraph)(e.graph)?"":" "+termToId(e.graph)}>>`;default:throw new Error("Unexpected termType: "+e.termType)}}exports.DefaultGraph=DefaultGraph,DEFAULTGRAPH=new DefaultGraph;class Quad extends Term{constructor(e,t,r,i){super(""),this._subject=e,this._predicate=t,this._object=r,this._graph=i||DEFAULTGRAPH}get termType(){return"Quad"}get subject(){return this._subject}get predicate(){return this._predicate}get object(){return this._object}get graph(){return this._graph}toJSON(){return{termType:this.termType,subject:this._subject.toJSON(),predicate:this._predicate.toJSON(),object:this._object.toJSON(),graph:this._graph.toJSON()}}equals(e){return!!e&&this._subject.equals(e.subject)&&this._predicate.equals(e.predicate)&&this._object.equals(e.object)&&this._graph.equals(e.graph)}}function escapeQuotes(e){return e.replace(escapedLiteral,(e,t)=>'"'+t.replace(/"/g,'""'))}function unescapeQuotes(e){return e.replace(escapedLiteral,(e,t)=>'"'+t.replace(/""/g,'"'))}function namedNode(e){return new NamedNode(e)}function blankNode(e){return new BlankNode(e||"n3-"+_blankNodeCounter++)}function literal(e,t){if("string"==typeof t)return new Literal(`"${e}"@`+t.toLowerCase());let r=t?t.value:"";return""===r&&("boolean"==typeof e?r=xsd.boolean:"number"==typeof e&&(Number.isFinite(e)?r=Number.isInteger(e)?xsd.integer:xsd.double:(r=xsd.double,Number.isNaN(e)||(e=0<e?"INF":"-INF")))),""===r||r===xsd.string?new Literal(`"${e}"`):new Literal(`"${e}"^^`+r)}function variable(e){return new Variable(e)}function defaultGraph(){return DEFAULTGRAPH}function quad(e,t,r,i){return new Quad(e,t,r,i)}exports.Triple=exports.Quad=Quad,Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _IRIs=_interopRequireDefault(require("./IRIs")),_queueMicrotask=_interopRequireDefault(require("queue-microtask"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const xsd=_IRIs.default["xsd"],escapeSequence=/\\u([a-fA-F0-9]{4})|\\U([a-fA-F0-9]{8})|\\([^])/g,escapeReplacements={"\\":"\\","'":"'",'"':'"',n:"\n",r:"\r",t:"\t",f:"\f",b:"\b",_:"_","~":"~",".":".","-":"-","!":"!",$:"$","&":"&","(":"(",")":")","*":"*","+":"+",",":",",";":";","=":"=","/":"/","?":"?","#":"#","@":"@","%":"%"},illegalIriChars=/[\x00-\x20<>\\"\{\}\|\^\`]/,lineModeRegExps={_iri:!0,_unescapedIri:!0,_simpleQuotedString:!0,_langcode:!0,_blank:!0,_newline:!0,_comment:!0,_whitespace:!0,_endOfFile:!0},invalidRegExp=/$0^/;class N3Lexer{constructor(e){if(this._iri=/^<((?:[^ <>{}\\]|\\[uU])+)>[ \t]*/,this._unescapedIri=/^<([^\x00-\x20<>\\"\{\}\|\^\`]*)>[ \t]*/,this._simpleQuotedString=/^"([^"\\\r\n]*)"(?=[^"])/,this._simpleApostropheString=/^'([^'\\\r\n]*)'(?=[^'])/,this._langcode=/^@([a-z]+(?:-[a-z0-9]+)*)(?=[^a-z0-9\-])/i,this._prefix=/^((?:[A-Za-z\xc0-\xd6\xd8-\xf6\xf8-\u02ff\u0370-\u037d\u037f-\u1fff\u200c\u200d\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])(?:\.?[\-0-9A-Z_a-z\xb7\xc0-\xd6\xd8-\xf6\xf8-\u037d\u037f-\u1fff\u200c\u200d\u203f\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])*)?:(?=[#\s<])/,this._prefixed=/^((?:[A-Za-z\xc0-\xd6\xd8-\xf6\xf8-\u02ff\u0370-\u037d\u037f-\u1fff\u200c\u200d\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])(?:\.?[\-0-9A-Z_a-z\xb7\xc0-\xd6\xd8-\xf6\xf8-\u037d\u037f-\u1fff\u200c\u200d\u203f\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])*)?:((?:(?:[0-:A-Z_a-z\xc0-\xd6\xd8-\xf6\xf8-\u02ff\u0370-\u037d\u037f-\u1fff\u200c\u200d\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff]|%[0-9a-fA-F]{2}|\\[!#-\/;=?\-@_~])(?:(?:[\.\-0-:A-Z_a-z\xb7\xc0-\xd6\xd8-\xf6\xf8-\u037d\u037f-\u1fff\u200c\u200d\u203f\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff]|%[0-9a-fA-F]{2}|\\[!#-\/;=?\-@_~])*(?:[\-0-:A-Z_a-z\xb7\xc0-\xd6\xd8-\xf6\xf8-\u037d\u037f-\u1fff\u200c\u200d\u203f\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff]|%[0-9a-fA-F]{2}|\\[!#-\/;=?\-@_~]))?)?)(?:[ \t]+|(?=\.?[,;!\^\s#()\[\]\{\}"'<>]))/,this._variable=/^\?(?:(?:[A-Z_a-z\xc0-\xd6\xd8-\xf6\xf8-\u02ff\u0370-\u037d\u037f-\u1fff\u200c\u200d\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])(?:[\-0-:A-Z_a-z\xb7\xc0-\xd6\xd8-\xf6\xf8-\u037d\u037f-\u1fff\u200c\u200d\u203f\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])*)(?=[.,;!\^\s#()\[\]\{\}"'<>])/,this._blank=/^_:((?:[0-9A-Z_a-z\xc0-\xd6\xd8-\xf6\xf8-\u02ff\u0370-\u037d\u037f-\u1fff\u200c\u200d\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])(?:\.?[\-0-9A-Z_a-z\xb7\xc0-\xd6\xd8-\xf6\xf8-\u037d\u037f-\u1fff\u200c\u200d\u203f\u2040\u2070-\u218f\u2c00-\u2fef\u3001-\ud7ff\uf900-\ufdcf\ufdf0-\ufffd]|[\ud800-\udb7f][\udc00-\udfff])*)(?:[ \t]+|(?=\.?[,;:\s#()\[\]\{\}"'<>]))/,this._number=/^[\-+]?(?:(\d+\.\d*|\.?\d+)[eE][\-+]?|\d*(\.)?)\d+(?=\.?[,;:\s#()\[\]\{\}"'<>])/,this._boolean=/^(?:true|false)(?=[.,;\s#()\[\]\{\}"'<>])/,this._keyword=/^@[a-z]+(?=[\s#<:])/i,this._sparqlKeyword=/^(?:PREFIX|BASE|GRAPH)(?=[\s#<])/i,this._shortPredicates=/^a(?=[\s#()\[\]\{\}"'<>])/,this._newline=/^[ \t]*(?:#[^\n\r]*)?(?:\r\n|\n|\r)[ \t]*/,this._comment=/#([^\n\r]*)/,this._whitespace=/^[ \t]+/,this._endOfFile=/^(?:#[^\n\r]*)?$/,this._lineMode=!!(e=e||{}).lineMode){this._n3Mode=!1;for(const t in this)!(t in lineModeRegExps)&&this[t]instanceof RegExp&&(this[t]=invalidRegExp)}else this._n3Mode=!1!==e.n3;this._comments=!!e.comments,this._literalClosingPos=0}_tokenizeToEnd(d,l){let o=this._input;for(var h=this._comments;;){let e,t;for(;e=this._newline.exec(o);)h&&(t=this._comment.exec(e[0]))&&d(null,{line:this._line,type:"comment",value:t[1],prefix:""}),o=o.substr(e[0].length,o.length),this._line++;if(!e&&(e=this._whitespace.exec(o))&&(o=o.substr(e[0].length,o.length)),this._endOfFile.test(o))return l&&(h&&(t=this._comment.exec(o))&&d(null,{line:this._line,type:"comment",value:t[1],prefix:""}),d(o=null,{line:this._line,type:"eof",value:"",prefix:""})),this._input=o;var c=this._line,_=o[0];let r="",i="",s="",a=null,n=0,u=!1;switch(_){case"^":if(o.length<3)break;if("^"!==o[1]){this._n3Mode&&(n=1,r="^");break}if(this._previousMarker="^^",o=o.substr(2),"<"!==o[0]){u=!0;break}case"<":if(a=this._unescapedIri.exec(o))r="IRI",i=a[1];else if(a=this._iri.exec(o)){if(i=this._unescape(a[1]),null===i||illegalIriChars.test(i))return f(this);r="IRI"}else 1<o.length&&"<"===o[1]?(r="<<",n=2):this._n3Mode&&1<o.length&&"="===o[1]&&(r="inverse",n=2,i=">");break;case">":1<o.length&&">"===o[1]&&(r=">>",n=2);break;case"_":((a=this._blank.exec(o))||l&&(a=this._blank.exec(o+" ")))&&(r="blank",s="_",i=a[1]);break;case'"':if(a=this._simpleQuotedString.exec(o))i=a[1];else if({value:i,matchLength:n}=this._parseLiteral(o),null===i)return f(this);null===a&&0===n||(r="literal",this._literalClosingPos=0);break;case"'":if(!this._lineMode){if(a=this._simpleApostropheString.exec(o))i=a[1];else if({value:i,matchLength:n}=this._parseLiteral(o),null===i)return f(this);null===a&&0===n||(r="literal",this._literalClosingPos=0)}break;case"?":this._n3Mode&&(a=this._variable.exec(o))&&(r="var",i=a[0]);break;case"@":"literal"===this._previousMarker&&(a=this._langcode.exec(o))?(r="langcode",i=a[1]):(a=this._keyword.exec(o))&&(r=a[0]);break;case".":if(1===o.length?l:o[1]<"0"||"9"<o[1]){r=".",n=1;break}case"0":case"1":case"2":case"3":case"4":case"5":case"6":case"7":case"8":case"9":case"+":case"-":(a=this._number.exec(o)||l&&(a=this._number.exec(o+" ")))&&(r="literal",i=a[0],s="string"==typeof a[1]?xsd.double:"string"==typeof a[2]?xsd.decimal:xsd.integer);break;case"B":case"b":case"p":case"P":case"G":case"g":(a=this._sparqlKeyword.exec(o))?r=a[0].toUpperCase():u=!0;break;case"f":case"t":(a=this._boolean.exec(o))?(r="literal",i=a[0],s=xsd.boolean):u=!0;break;case"a":(a=this._shortPredicates.exec(o))?(r="abbreviation",i="a"):u=!0;break;case"=":this._n3Mode&&1<o.length&&(r="abbreviation",i=">"!==o[1]?(n=1,"="):(n=2,">"));break;case"!":if(!this._n3Mode)break;case",":case";":case"[":case"]":case"(":case")":case"{":case"}":this._lineMode||(n=1,r=_);break;default:u=!0}if(u&&("@prefix"!==this._previousMarker&&"PREFIX"!==this._previousMarker||!(a=this._prefix.exec(o))?((a=this._prefixed.exec(o))||l&&(a=this._prefixed.exec(o+" ")))&&(r="prefixed",s=a[1]||"",i=this._unescape(a[2])):(r="prefix",i=a[1]||"")),"^^"===this._previousMarker)switch(r){case"prefixed":r="type";break;case"IRI":r="typeIRI";break;default:r=""}if(!r)return l||!/^'''|^"""/.test(o)&&/\n|\r/.test(o)?f(this):this._input=o;c={line:c,type:r,value:i,prefix:s};d(null,c),this.previousToken=c,this._previousMarker=r,o=o.substr(n||a[0].length,o.length)}function f(e){d(e._syntaxError(/^\S*/.exec(o)[0]))}}_unescape(e){let s=!1;e=e.replace(escapeSequence,(e,t,r,i)=>{if("string"==typeof t)return String.fromCharCode(Number.parseInt(t,16));if("string"!=typeof r)return i in escapeReplacements?escapeReplacements[i]:(s=!0,"");i=Number.parseInt(r,16);return i<=65535?String.fromCharCode(Number.parseInt(r,16)):String.fromCharCode(55296+((i-=65536)>>10),56320+(1023&i))});return s?null:e}_parseLiteral(r){if(3<=r.length){var e=r.match(/^(?:"""|"|'''|'|)/)[0],i=e.length;let t=Math.max(this._literalClosingPos,i);for(;0<(t=r.indexOf(e,t));){let e=0;for(;"\\"===r[t-e-1];)e++;if(e%2==0){const n=r.substring(i,t);var s=n.split(/\r\n|\r|\n/).length-1,a=t+i;if(1===i&&0!=s||3===i&&this._lineMode)break;return this._line+=s,{value:this._unescape(n),matchLength:a}}t++}this._literalClosingPos=r.length-i+1}return{value:"",matchLength:0}}_syntaxError(e){this._input=null;const t=new Error(`Unexpected "${e}" on line ${this._line}.`);return t.context={token:void 0,line:this._line,previousToken:this.previousToken},t}_readStartingBom(e){return e.startsWith("\ufeff")?e.substr(1):e}tokenize(e,t){if(this._line=1,"string"==typeof e){if(this._input=this._readStartingBom(e),"function"!=typeof t){const i=[];let r;if(this._tokenizeToEnd((e,t)=>e?r=e:i.push(t),!0),r)throw r;return i}(0,_queueMicrotask.default)(()=>this._tokenizeToEnd(t,!0))}else this._pendingBuffer=null,"function"==typeof e.setEncoding&&e.setEncoding("utf8"),e.on("data",e=>{null!==this._input&&0!==e.length&&(this._pendingBuffer&&(e=Buffer.concat([this._pendingBuffer,e]),this._pendingBuffer=null),128&e[e.length-1]?this._pendingBuffer=e:(void 0===this._input?this._input=this._readStartingBom("string"==typeof e?e:e.toString()):this._input+=e,this._tokenizeToEnd(t,!1)))}),e.on("end",()=>{"string"==typeof this._input&&this._tokenizeToEnd(t,!0)}),e.on("error",t)}}exports.default=N3Lexer,Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;_N3Lexer=_interopRequireDefault(require("./N3Lexer")),_N3DataFactory=_interopRequireDefault(require("./N3DataFactory")),_IRIs=_interopRequireDefault(require("./IRIs"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}let blankNodePrefix=0;class N3Parser{constructor(e){this._contextStack=[],this._graph=null,this._setBase((e=e||{}).baseIRI),e.factory&&initDataFactory(this,e.factory);var t="string"==typeof e.format?e.format.match(/\w*$/)[0].toLowerCase():"",r=/turtle/.test(t),i=/trig/.test(t),s=/triple/.test(t),a=/quad/.test(t),n=this._n3Mode=/n3/.test(t),a=s||a;(this._supportsNamedGraphs=!(r||n))||(this._readPredicateOrNamedGraph=this._readPredicate),this._supportsQuads=!(r||i||s||n),this._supportsRDFStar=""===t||/star|\*$/.test(t),a&&(this._resolveRelativeIRI=e=>null),this._blankNodePrefix="string"!=typeof e.blankNodePrefix?"":e.blankNodePrefix.replace(/^(?!_:)/,"_:"),this._lexer=e.lexer||new _N3Lexer.default({lineMode:a,n3:n}),this._explicitQuantifiers=!!e.explicitQuantifiers}static _resetBlankNodePrefix(){blankNodePrefix=0}_setBase(e){var t;e?(0<=(t=e.indexOf("#"))&&(e=e.substr(0,t)),this._base=e,this._basePath=e.indexOf("/")<0?e:e.replace(/[^\/?]*(?:\?.*)?$/,""),e=e.match(/^(?:([a-z][a-z0-9+.-]*:))?(?:\/\/[^\/]*)?/i),this._baseRoot=e[0],this._baseScheme=e[1]):(this._base="",this._basePath="")}_saveContext(e,t,r,i,s){var a=this._n3Mode;this._contextStack.push({subject:r,predicate:i,object:s,graph:t,type:e,inverse:!!a&&this._inversePredicate,blankPrefix:a?this._prefixes._:"",quantified:a?this._quantified:null}),a&&(this._inversePredicate=!1,this._prefixes._=this._graph?this._graph.id.substr(2)+".":".",this._quantified=Object.create(this._quantified))}_restoreContext(){var e=this._contextStack.pop(),t=this._n3Mode;this._subject=e.subject,this._predicate=e.predicate,this._object=e.object,this._graph=e.graph,t&&(this._inversePredicate=e.inverse,this._prefixes._=e.blankPrefix,this._quantified=e.quantified)}_readInTopContext(e){switch(e.type){case"eof":return null!==this._graph?this._error("Unclosed graph",e):(delete this._prefixes._,this._callback(null,null,this._prefixes));case"PREFIX":this._sparqlStyle=!0;case"@prefix":return this._readPrefix;case"BASE":this._sparqlStyle=!0;case"@base":return this._readBaseIRI;case"{":if(this._supportsNamedGraphs)return this._graph="",this._subject=null,this._readSubject;case"GRAPH":if(this._supportsNamedGraphs)return this._readNamedGraphLabel;default:return this._readSubject(e)}}_readEntity(e,t){let r;switch(e.type){case"IRI":case"typeIRI":var i=this._resolveIRI(e.value);if(null===i)return this._error("Invalid IRI",e);r=this._namedNode(i);break;case"type":case"prefixed":i=this._prefixes[e.prefix];if(void 0===i)return this._error(`Undefined prefix "${e.prefix}:"`,e);r=this._namedNode(i+e.value);break;case"blank":r=this._blankNode(this._prefixes[e.prefix]+e.value);break;case"var":r=this._variable(e.value.substr(1));break;default:return this._error("Expected entity but got "+e.type,e)}return!t&&this._n3Mode&&r.id in this._quantified&&(r=this._quantified[r.id]),r}_readSubject(e){switch(this._predicate=null,e.type){case"[":return this._saveContext("blank",this._graph,this._subject=this._blankNode(),null,null),this._readBlankNodeHead;case"(":return this._saveContext("list",this._graph,this.RDF_NIL,null,null),this._subject=null,this._readListItem;case"{":return this._n3Mode?(this._saveContext("formula",this._graph,this._graph=this._blankNode(),null,null),this._readSubject):this._error("Unexpected graph",e);case"}":return this._readPunctuation(e);case"@forSome":return this._n3Mode?(this._subject=null,this._predicate=this.N3_FORSOME,this._quantifier=this._blankNode,this._readQuantifierList):this._error('Unexpected "@forSome"',e);case"@forAll":return this._n3Mode?(this._subject=null,this._predicate=this.N3_FORALL,this._quantifier=this._variable,this._readQuantifierList):this._error('Unexpected "@forAll"',e);case"literal":if(!this._n3Mode)return this._error("Unexpected literal",e);if(0===e.prefix.length)return this._literalValue=e.value,this._completeSubjectLiteral;this._subject=this._literal(e.value,this._namedNode(e.prefix));break;case"<<":return this._supportsRDFStar?(this._saveContext("<<",this._graph,null,null,null),this._graph=null,this._readSubject):this._error("Unexpected RDF* syntax",e);default:if(void 0===(this._subject=this._readEntity(e)))return;if(this._n3Mode)return this._getPathReader(this._readPredicateOrNamedGraph)}return this._readPredicateOrNamedGraph}_readPredicate(e){var t=e.type;switch(t){case"inverse":this._inversePredicate=!0;case"abbreviation":this._predicate=this.ABBREVIATIONS[e.value];break;case".":case"]":case"}":return null===this._predicate?this._error("Unexpected "+t,e):(this._subject=null,"]"===t?this._readBlankNodeTail(e):this._readPunctuation(e));case";":return null!==this._predicate?this._readPredicate:this._error("Expected predicate but got ;",e);case"[":if(this._n3Mode)return this._saveContext("blank",this._graph,this._subject,this._subject=this._blankNode(),null),this._readBlankNodeHead;case"blank":if(!this._n3Mode)return this._error("Disallowed blank node as predicate",e);default:if(void 0===(this._predicate=this._readEntity(e)))return}return this._readObject}_readObject(e){switch(e.type){case"literal":if(0===e.prefix.length)return this._literalValue=e.value,this._readDataTypeOrLang;this._object=this._literal(e.value,this._namedNode(e.prefix));break;case"[":return this._saveContext("blank",this._graph,this._subject,this._predicate,this._subject=this._blankNode()),this._readBlankNodeHead;case"(":return this._saveContext("list",this._graph,this._subject,this._predicate,this.RDF_NIL),this._subject=null,this._readListItem;case"{":return this._n3Mode?(this._saveContext("formula",this._graph,this._subject,this._predicate,this._graph=this._blankNode()),this._readSubject):this._error("Unexpected graph",e);case"<<":return this._supportsRDFStar?(this._saveContext("<<",this._graph,this._subject,this._predicate,null),this._graph=null,this._readSubject):this._error("Unexpected RDF* syntax",e);default:if(void 0===(this._object=this._readEntity(e)))return;if(this._n3Mode)return this._getPathReader(this._getContextEndReader())}return this._getContextEndReader()}_readPredicateOrNamedGraph(e){return"{"===e.type?this._readGraph(e):this._readPredicate(e)}_readGraph(e){return"{"!==e.type?this._error("Expected graph but got "+e.type,e):(this._graph=this._subject,this._subject=null,this._readSubject)}_readBlankNodeHead(e){return"]"===e.type?(this._subject=null,this._readBlankNodeTail(e)):(this._predicate=null,this._readPredicate(e))}_readBlankNodeTail(e){if("]"!==e.type)return this._readBlankNodePunctuation(e);null!==this._subject&&this._emit(this._subject,this._predicate,this._object,this._graph);e=null===this._predicate;return this._restoreContext(),null!==this._object?this._getContextEndReader():null!==this._predicate?this._readObject:e?this._readPredicateOrNamedGraph:this._readPredicateAfterBlank}_readPredicateAfterBlank(e){switch(e.type){case".":case"}":return this._subject=null,this._readPunctuation(e);default:return this._readPredicate(e)}}_readListItem(e){let t=null,r=null,i=this._readListItem;const s=this._subject,a=this._contextStack,n=a[a.length-1];switch(e.type){case"[":this._saveContext("blank",this._graph,r=this._blankNode(),this.RDF_FIRST,this._subject=t=this._blankNode()),i=this._readBlankNodeHead;break;case"(":this._saveContext("list",this._graph,r=this._blankNode(),this.RDF_FIRST,this.RDF_NIL),this._subject=null;break;case")":if(this._restoreContext(),0!==a.length&&"list"===a[a.length-1].type&&this._emit(this._subject,this._predicate,this._object,this._graph),null===this._predicate){if(i=this._readPredicate,this._subject===this.RDF_NIL)return i}else if(i=this._getContextEndReader(),this._object===this.RDF_NIL)return i;r=this.RDF_NIL;break;case"literal":i=0===e.prefix.length?(this._literalValue=e.value,this._readListItemDataTypeOrLang):(t=this._literal(e.value,this._namedNode(e.prefix)),this._getContextEndReader());break;case"{":return this._n3Mode?(this._saveContext("formula",this._graph,this._subject,this._predicate,this._graph=this._blankNode()),this._readSubject):this._error("Unexpected graph",e);default:if(void 0===(t=this._readEntity(e)))return}if(null===r&&(this._subject=r=this._blankNode()),null===s?null===n.predicate?n.subject=r:n.object=r:this._emit(s,this.RDF_REST,r,this._graph),null!==t){if(this._n3Mode&&("IRI"===e.type||"prefixed"===e.type))return this._saveContext("item",this._graph,r,this.RDF_FIRST,t),this._subject=t,this._predicate=null,this._getPathReader(this._readListItem);this._emit(r,this.RDF_FIRST,t,this._graph)}return i}_readDataTypeOrLang(e){return this._completeObjectLiteral(e,!1)}_readListItemDataTypeOrLang(e){return this._completeObjectLiteral(e,!0)}_completeLiteral(e){let t=this._literal(this._literalValue);switch(e.type){case"type":case"typeIRI":var r=this._readEntity(e);if(void 0===r)return;t=this._literal(this._literalValue,r),e=null;break;case"langcode":t=this._literal(this._literalValue,e.value),e=null}return{token:e,literal:t}}_completeSubjectLiteral(e){return this._subject=this._completeLiteral(e).literal,this._readPredicateOrNamedGraph}_completeObjectLiteral(e,t){e=this._completeLiteral(e);if(e)return this._object=e.literal,t&&this._emit(this._subject,this.RDF_FIRST,this._object,this._graph),null===e.token?this._getContextEndReader():(this._readCallback=this._getContextEndReader(),this._readCallback(e.token))}_readFormulaTail(e){return"}"!==e.type?this._readPunctuation(e):(null!==this._subject&&this._emit(this._subject,this._predicate,this._object,this._graph),this._restoreContext(),null===this._object?this._readPredicate:this._getContextEndReader())}_readPunctuation(e){let t,r=this._graph;var i,s,a=this._subject,n=this._inversePredicate;switch(e.type){case"}":if(null===this._graph)return this._error("Unexpected graph closing",e);if(this._n3Mode)return this._readFormulaTail(e);this._graph=null;case".":this._subject=null,t=this._contextStack.length?this._readSubject:this._readInTopContext,n&&(this._inversePredicate=!1);break;case";":t=this._readPredicate;break;case",":t=this._readObject;break;default:if(this._supportsQuads&&null===this._graph&&void 0!==(r=this._readEntity(e))){t=this._readQuadPunctuation;break}return this._error(`Expected punctuation to follow "${this._object.id}"`,e)}return null!==a&&(i=this._predicate,s=this._object,n?this._emit(s,i,a,r):this._emit(a,i,s,r)),t}_readBlankNodePunctuation(e){let t;switch(e.type){case";":t=this._readPredicate;break;case",":t=this._readObject;break;default:return this._error(`Expected punctuation to follow "${this._object.id}"`,e)}return this._emit(this._subject,this._predicate,this._object,this._graph),t}_readQuadPunctuation(e){return"."!==e.type?this._error("Expected dot to follow quad",e):this._readInTopContext}_readPrefix(e){return"prefix"!==e.type?this._error("Expected prefix to follow @prefix",e):(this._prefix=e.value,this._readPrefixIRI)}_readPrefixIRI(e){if("IRI"!==e.type)return this._error(`Expected IRI to follow prefix "${this._prefix}:"`,e);e=this._readEntity(e);return this._prefixes[this._prefix]=e.value,this._prefixCallback(this._prefix,e),this._readDeclarationPunctuation}_readBaseIRI(e){var t="IRI"===e.type&&this._resolveIRI(e.value);return t?(this._setBase(t),this._readDeclarationPunctuation):this._error("Expected valid IRI to follow base declaration",e)}_readNamedGraphLabel(e){switch(e.type){case"IRI":case"blank":case"prefixed":return this._readSubject(e),this._readGraph;case"[":return this._readNamedGraphBlankLabel;default:return this._error("Invalid graph label",e)}}_readNamedGraphBlankLabel(e){return"]"!==e.type?this._error("Invalid graph label",e):(this._subject=this._blankNode(),this._readGraph)}_readDeclarationPunctuation(e){return this._sparqlStyle?(this._sparqlStyle=!1,this._readInTopContext(e)):"."!==e.type?this._error("Expected declaration to end with a dot",e):this._readInTopContext}_readQuantifierList(e){let t;switch(e.type){case"IRI":case"prefixed":if(void 0!==(t=this._readEntity(e,!0)))break;default:return this._error("Unexpected "+e.type,e)}return this._explicitQuantifiers?(null===this._subject?this._emit(this._graph||this.DEFAULTGRAPH,this._predicate,this._subject=this._blankNode(),this.QUANTIFIERS_GRAPH):this._emit(this._subject,this.RDF_REST,this._subject=this._blankNode(),this.QUANTIFIERS_GRAPH),this._emit(this._subject,this.RDF_FIRST,t,this.QUANTIFIERS_GRAPH)):this._quantified[t.id]=this._quantifier(this._blankNode().value),this._readQuantifierPunctuation}_readQuantifierPunctuation(e){return","===e.type?this._readQuantifierList:(this._explicitQuantifiers&&(this._emit(this._subject,this.RDF_REST,this.RDF_NIL,this.QUANTIFIERS_GRAPH),this._subject=null),this._readCallback=this._getContextEndReader(),this._readCallback(e))}_getPathReader(e){return this._afterPath=e,this._readPath}_readPath(e){switch(e.type){case"!":return this._readForwardPath;case"^":return this._readBackwardPath;default:var t=this._contextStack,t=t.length&&t[t.length-1];return t&&"item"===t.type&&(t=this._subject,this._restoreContext(),this._emit(this._subject,this.RDF_FIRST,t,this._graph)),this._afterPath(e)}}_readForwardPath(e){let t,r;var i=this._blankNode();if(void 0!==(r=this._readEntity(e)))return null===this._predicate?(t=this._subject,this._subject=i):(t=this._object,this._object=i),this._emit(t,r,i,this._graph),this._readPath}_readBackwardPath(e){var t=this._blankNode();let r,i;if(void 0!==(r=this._readEntity(e)))return null===this._predicate?(i=this._subject,this._subject=t):(i=this._object,this._object=t),this._emit(t,r,i,this._graph),this._readPath}_readRDFStarTailOrGraph(e){return">>"!==e.type?this._supportsQuads&&null===this._graph&&void 0!==(this._graph=this._readEntity(e))?this._readRDFStarTail:this._error(`Expected >> to follow "${this._object.id}"`,e):this._readRDFStarTail(e)}_readRDFStarTail(e){if(">>"!==e.type)return this._error("Expected >> but got "+e.type,e);e=this._quad(this._subject,this._predicate,this._object,this._graph||this.DEFAULTGRAPH);return this._restoreContext(),null===this._subject?(this._subject=e,this._readPredicate):(this._object=e,this._getContextEndReader())}_getContextEndReader(){var e=this._contextStack;if(!e.length)return this._readPunctuation;switch(e[e.length-1].type){case"blank":return this._readBlankNodeTail;case"list":return this._readListItem;case"formula":return this._readFormulaTail;case"<<":return this._readRDFStarTailOrGraph}}_emit(e,t,r,i){this._callback(null,this._quad(e,t,r,i||this.DEFAULTGRAPH))}_error(e,t){const r=new Error(`${e} on line ${t.line}.`);r.context={token:t,line:t.line,previousToken:this._lexer.previousToken},this._callback(r),this._callback=noop}_resolveIRI(e){return/^[a-z][a-z0-9+.-]*:/i.test(e)?e:this._resolveRelativeIRI(e)}_resolveRelativeIRI(e){if(!e.length)return this._base;switch(e[0]){case"#":return this._base+e;case"?":return this._base.replace(/(?:\?.*)?$/,e);case"/":return("/"===e[1]?this._baseScheme:this._baseRoot)+this._removeDotSegments(e);default:return/^[^/:]*:/.test(e)?null:this._removeDotSegments(this._basePath+e)}}_removeDotSegments(e){if(!/(^|\/)\.\.?($|[/#?])/.test(e))return e;var t=e.length;let r="",i=-1,s=-1,a=0,n="/";for(;i<t;){switch(n){case":":if(s<0&&"/"===e[++i]&&"/"===e[++i])for(;(s=i+1)<t&&"/"!==e[s];)i=s;break;case"?":case"#":i=t;break;case"/":if("."===e[i+1])switch(n=e[++i+1],n){case"/":r+=e.substring(a,i-1),a=i+1;break;case void 0:case"?":case"#":return r+e.substring(a,i)+e.substr(i+1);case".":if(n=e[++i+1],void 0===n||"/"===n||"?"===n||"#"===n){if(r+=e.substring(a,i-2),(a=r.lastIndexOf("/"))>=s&&(r=r.substr(0,a)),"/"!==n)return r+"/"+e.substr(i+1);a=i+1}}}n=e[++i]}return r+e.substring(a)}parse(e,t,r){if(this._readCallback=this._readInTopContext,this._sparqlStyle=!1,this._prefixes=Object.create(null),this._prefixes._=this._blankNodePrefix?this._blankNodePrefix.substr(2):`b${blankNodePrefix++}_`,this._prefixCallback=r||noop,this._inversePredicate=!1,this._quantified=Object.create(null),!t){const i=[];let r;if(this._callback=(e,t)=>{e?r=e:t&&i.push(t)},this._lexer.tokenize(e).every(e=>this._readCallback=this._readCallback(e)),r)throw r;return i}this._callback=t,this._lexer.tokenize(e,(e,t)=>{null!==e?(this._callback(e),this._callback=noop):this._readCallback&&(this._readCallback=this._readCallback(t))})}}function noop(){}function initDataFactory(e,t){const r=t.namedNode;e._namedNode=r,e._blankNode=t.blankNode,e._literal=t.literal,e._variable=t.variable,e._quad=t.quad,e.DEFAULTGRAPH=t.defaultGraph(),e.RDF_FIRST=r(_IRIs.default.rdf.first),e.RDF_REST=r(_IRIs.default.rdf.rest),e.RDF_NIL=r(_IRIs.default.rdf.nil),e.N3_FORALL=r(_IRIs.default.r.forAll),e.N3_FORSOME=r(_IRIs.default.r.forSome),e.ABBREVIATIONS={a:r(_IRIs.default.rdf.type),"=":r(_IRIs.default.owl.sameAs),">":r(_IRIs.default.log.implies)},e.QUANTIFIERS_GRAPH=r("urn:n3:quantifiers")}exports.default=N3Parser,initDataFactory(N3Parser.prototype,_N3DataFactory.default),Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;var _N3DataFactory=_interopRequireWildcard(require("./N3DataFactory")),_readableStream=require("readable-stream"),_IRIs=_interopRequireDefault(require("./IRIs"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function _getRequireWildcardCache(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return _getRequireWildcardCache=function(){return e},e}function _interopRequireWildcard(e){if(e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache();if(t&&t.has(e))return t.get(e);var r,i,s={},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(r in e)Object.prototype.hasOwnProperty.call(e,r)&&((i=a?Object.getOwnPropertyDescriptor(e,r):null)&&(i.get||i.set)?Object.defineProperty(s,r,i):s[r]=e[r]);return s.default=e,t&&t.set(e,s),s}class N3Store{constructor(e,t){this._size=0,this._graphs=Object.create(null),this._id=0,this._ids=Object.create(null),this._ids["><"]=0,this._entities=Object.create(null),this._blankNodeIndex=0,t||!e||e[0]||(t=e,e=null),this._factory=(t=t||{}).factory||_N3DataFactory.default,e&&this.addQuads(e)}get size(){let e=this._size;if(null!==e)return e;e=0;var t,r,i=this._graphs;for(const s in i)for(const a in t=i[s].subjects)for(const n in r=t[a])e+=Object.keys(r[n]).length;return this._size=e}_addToIndex(e,t,r,i){const s=e[t]||(e[t]={}),a=s[r]||(s[r]={});r=i in a;return r||(a[i]=null),!r}_removeFromIndex(e,t,r,i){const s=e[t],a=s[r];delete a[i];for(const n in a)return;delete s[r];for(const u in s)return;delete e[t]}_findInIndex(e,t,r,i,s,a,n,u,d,l){let o,h,c;var _=1<!t+!r+!i?Object.keys(this._ids):this._entities;t&&(o=e,(e={})[t]=o[t]);for(const g in e){var f=_[g];if(h=e[g]){r&&(o=h,(h={})[r]=o[r]);for(const m in h){var p=_[m];if(c=h[m]){var b=i?i in c?[i]:[]:Object.keys(c);for(let e=0;e<b.length;e++){const y={subject:null,predicate:null,object:null};y[s]=(0,_N3DataFactory.termFromId)(f,this._factory),y[a]=(0,_N3DataFactory.termFromId)(p,this._factory),y[n]=(0,_N3DataFactory.termFromId)(_[b[e]],this._factory);var x=this._factory.quad(y.subject,y.predicate,y.object,(0,_N3DataFactory.termFromId)(u,this._factory));if(l)l.push(x);else if(d(x))return!0}}}}}return l}_loop(e,t){for(const r in e)t(r)}_loopByKey0(e,t,r){let i,s;if(i=e[t])for(s in i)r(s)}_loopByKey1(e,t,r){let i;for(i in e)e[i][t]&&r(i)}_loopBy2Keys(e,t,r,i){let s,a,n;if((s=e[t])&&(a=s[r]))for(n in a)i(n)}_countInIndex(e,t,r,i){let s=0,a,n,u;t&&(a=e,(e={})[t]=a[t]);for(const d in e)if(n=e[d]){r&&(a=n,(n={})[r]=a[r]);for(const l in n)(u=n[l])&&(i?i in u&&s++:s+=Object.keys(u).length)}return s}_getGraphs(e){if(!isString(e))return this._graphs;const t={};return t[e]=this._graphs[e],t}_uniqueEntities(t){const r=Object.create(null);return e=>{e in r||(r[e]=!0,t((0,_N3DataFactory.termFromId)(this._entities[e],this._factory)))}}add(e){return this.addQuad(e),this}addQuad(e,t,r,i){t||(i=e.graph,r=e.object,t=e.predicate,e=e.subject),e=(0,_N3DataFactory.termToId)(e),t=(0,_N3DataFactory.termToId)(t),r=(0,_N3DataFactory.termToId)(r),i=(0,_N3DataFactory.termToId)(i);let s=this._graphs[i];s||(s=this._graphs[i]={subjects:{},predicates:{},objects:{}},Object.freeze(s));const a=this._ids,n=this._entities;e=a[e]||(a[n[++this._id]=e]=this._id),t=a[t]||(a[n[++this._id]=t]=this._id),r=a[r]||(a[n[++this._id]=r]=this._id);i=this._addToIndex(s.subjects,e,t,r);return this._addToIndex(s.predicates,t,r,e),this._addToIndex(s.objects,r,e,t),this._size=null,i}addQuads(t){for(let e=0;e<t.length;e++)this.addQuad(t[e])}delete(e){return this.removeQuad(e),this}has(e){return 0!==this.getQuads(e.subject,e.predicate,e.object,e.graph).length}import(e){return e.on("data",e=>{this.addQuad(e)}),e}removeQuad(e,t,r,i){t||(i=e.graph,r=e.object,t=e.predicate,e=e.subject),e=(0,_N3DataFactory.termToId)(e),t=(0,_N3DataFactory.termToId)(t),r=(0,_N3DataFactory.termToId)(r),i=(0,_N3DataFactory.termToId)(i);const s=this._ids,a=this._graphs;let n,u,d;if(!((e=s[e])&&(t=s[t])&&(r=s[r])&&(n=a[i])&&(u=n.subjects[e])&&(d=u[t])&&r in d))return!1;for(e in this._removeFromIndex(n.subjects,e,t,r),this._removeFromIndex(n.predicates,t,r,e),this._removeFromIndex(n.objects,r,e,t),null!==this._size&&this._size--,n.subjects)return!0;return delete a[i],!0}removeQuads(t){for(let e=0;e<t.length;e++)this.removeQuad(t[e])}remove(e){return e.on("data",e=>{this.removeQuad(e)}),e}removeMatches(t,r,i,s){const a=new _readableStream.Readable({objectMode:!0});return a._read=()=>{for(const e of this.getQuads(t,r,i,s))a.push(e);a.push(null)},this.remove(a)}deleteGraph(e){return this.removeMatches(null,null,null,e)}getQuads(e,t,r,i){e=e&&(0,_N3DataFactory.termToId)(e),t=t&&(0,_N3DataFactory.termToId)(t),r=r&&(0,_N3DataFactory.termToId)(r),i=i&&(0,_N3DataFactory.termToId)(i);var s=[],a=this._getGraphs(i),i=this._ids;let n,u,d,l;if(isString(e)&&!(u=i[e])||isString(t)&&!(d=i[t])||isString(r)&&!(l=i[r]))return s;for(const o in a)(n=a[o])&&(u?l?this._findInIndex(n.objects,l,u,d,"object","subject","predicate",o,null,s):this._findInIndex(n.subjects,u,d,null,"subject","predicate","object",o,null,s):d?this._findInIndex(n.predicates,d,l,null,"predicate","object","subject",o,null,s):l?this._findInIndex(n.objects,l,null,null,"object","subject","predicate",o,null,s):this._findInIndex(n.subjects,null,null,null,"subject","predicate","object",o,null,s));return s}match(e,t,r,i){return new DatasetCoreAndReadableStream(this,e,t,r,i)}countQuads(e,t,r,i){e=e&&(0,_N3DataFactory.termToId)(e),t=t&&(0,_N3DataFactory.termToId)(t),r=r&&(0,_N3DataFactory.termToId)(r),i=i&&(0,_N3DataFactory.termToId)(i);var s=this._getGraphs(i),i=this._ids;let a=0,n,u,d,l;if(isString(e)&&!(u=i[e])||isString(t)&&!(d=i[t])||isString(r)&&!(l=i[r]))return 0;for(const o in s)(n=s[o])&&(a+=e?r?this._countInIndex(n.objects,l,u,d):this._countInIndex(n.subjects,u,d,l):t?this._countInIndex(n.predicates,d,l,u):this._countInIndex(n.objects,l,u,d));return a}forEach(t,e,r,i,s){this.some(e=>(t(e),!1),e,r,i,s)}every(t,e,r,i,s){let a=!1;s=!this.some(e=>(a=!0,!t(e)),e,r,i,s);return a&&s}some(e,t,r,i,s){t=t&&(0,_N3DataFactory.termToId)(t),r=r&&(0,_N3DataFactory.termToId)(r),i=i&&(0,_N3DataFactory.termToId)(i),s=s&&(0,_N3DataFactory.termToId)(s);var a=this._getGraphs(s),s=this._ids;let n,u,d,l;if(isString(t)&&!(u=s[t])||isString(r)&&!(d=s[r])||isString(i)&&!(l=s[i]))return!1;for(const o in a)if(n=a[o])if(u){if(l){if(this._findInIndex(n.objects,l,u,d,"object","subject","predicate",o,e,null))return!0}else if(this._findInIndex(n.subjects,u,d,null,"subject","predicate","object",o,e,null))return!0}else if(d){if(this._findInIndex(n.predicates,d,l,null,"predicate","object","subject",o,e,null))return!0}else if(l){if(this._findInIndex(n.objects,l,null,null,"object","subject","predicate",o,e,null))return!0}else if(this._findInIndex(n.subjects,null,null,null,"subject","predicate","object",o,e,null))return!0;return!1}getSubjects(e,t,r){const i=[];return this.forSubjects(e=>{i.push(e)},e,t,r),i}forSubjects(e,t,r,i){t=t&&(0,_N3DataFactory.termToId)(t),r=r&&(0,_N3DataFactory.termToId)(r),i=i&&(0,_N3DataFactory.termToId)(i);var s=this._ids,a=this._getGraphs(i);let n,u,d;if(e=this._uniqueEntities(e),!(isString(t)&&!(u=s[t])||isString(r)&&!(d=s[r])))for(i in a)(n=a[i])&&(u?d?this._loopBy2Keys(n.predicates,u,d,e):this._loopByKey1(n.subjects,u,e):d?this._loopByKey0(n.objects,d,e):this._loop(n.subjects,e))}getPredicates(e,t,r){const i=[];return this.forPredicates(e=>{i.push(e)},e,t,r),i}forPredicates(e,t,r,i){t=t&&(0,_N3DataFactory.termToId)(t),r=r&&(0,_N3DataFactory.termToId)(r),i=i&&(0,_N3DataFactory.termToId)(i);var s=this._ids,a=this._getGraphs(i);let n,u,d;if(e=this._uniqueEntities(e),!(isString(t)&&!(u=s[t])||isString(r)&&!(d=s[r])))for(i in a)(n=a[i])&&(u?d?this._loopBy2Keys(n.objects,d,u,e):this._loopByKey0(n.subjects,u,e):d?this._loopByKey1(n.predicates,d,e):this._loop(n.predicates,e))}getObjects(e,t,r){const i=[];return this.forObjects(e=>{i.push(e)},e,t,r),i}forObjects(e,t,r,i){t=t&&(0,_N3DataFactory.termToId)(t),r=r&&(0,_N3DataFactory.termToId)(r),i=i&&(0,_N3DataFactory.termToId)(i);var s=this._ids,a=this._getGraphs(i);let n,u,d;if(e=this._uniqueEntities(e),!(isString(t)&&!(u=s[t])||isString(r)&&!(d=s[r])))for(i in a)(n=a[i])&&(u?d?this._loopBy2Keys(n.subjects,u,d,e):this._loopByKey1(n.objects,u,e):d?this._loopByKey0(n.predicates,d,e):this._loop(n.objects,e))}getGraphs(e,t,r){const i=[];return this.forGraphs(e=>{i.push(e)},e,t,r),i}forGraphs(t,e,r,i){for(const s in this._graphs)this.some(e=>(t(e.graph),!0),e,r,i,s)}createBlankNode(e){let t,r;if(e)for(t=e="_:"+e,r=1;this._ids[t];)t=e+r++;else for(;t="_:b"+this._blankNodeIndex++,this._ids[t];);return this._ids[t]=++this._id,this._entities[this._id]=t,this._factory.blankNode(t.substr(2))}extractLists({remove:t=!1,ignoreErrors:e=!1}={}){const r={},_=e?()=>!0:(e,t)=>{throw new Error(e.value+" "+t)},i=this.getQuads(null,_IRIs.default.rdf.rest,_IRIs.default.rdf.nil,null),f=t?[...i]:[];return i.forEach(e=>{const a=[];let n=!1,u,d;var l=e.graph;let o=e.subject;for(;o&&!n;){var h=this.getQuads(null,null,o,null),c=this.getQuads(o,null,null,null);let t,r=null,i=null,s=null;for(let e=0;e<c.length&&!n;e++)t=c[e],t.graph.equals(l)?u?n=_(o,"has non-list arcs out"):t.predicate.value===_IRIs.default.rdf.first?r?n=_(o,"has multiple rdf:first arcs"):f.push(r=t):t.predicate.value===_IRIs.default.rdf.rest?i?n=_(o,"has multiple rdf:rest arcs"):f.push(i=t):h.length?n=_(o,"can't be subject and object"):(u=t,d="subject"):n=_(o,"not confined to single graph");for(let e=0;e<h.length&&!n;++e)t=h[e],u?n=_(o,"can't have coreferences"):t.predicate.value===_IRIs.default.rdf.rest?s?n=_(o,"has incoming rdf:rest arcs"):s=t:(u=t,d="object");r?a.unshift(r.object):n=_(o,"has no list head"),o=s&&s.subject}n?t=!1:u&&(r[u[d].value]=a)}),t&&this.removeQuads(f),r}*[Symbol.iterator](){yield*this.getQuads()}}function isString(e){return"string"==typeof e||e instanceof String}exports.default=N3Store;class DatasetCoreAndReadableStream extends _readableStream.Readable{constructor(e,t,r,i,s){super({objectMode:!0}),Object.assign(this,{n3Store:e,subject:t,predicate:r,object:i,graph:s})}get filtered(){if(!this._filtered){const{n3Store:t,graph:r,object:i,predicate:s,subject:a}=this;var e=t.getQuads(a,s,i,r);this._filtered=new N3Store(e,{factory:t._factory})}return this._filtered}get size(){return this.filtered.size}_read(){for(const e of this.filtered.getQuads())this.push(e);this.push(null)}add(e){return this.filtered.add(e)}delete(e){return this.filtered.delete(e)}has(e){return this.filtered.has(e)}match(e,t,r,i){return new DatasetCoreAndReadableStream(this.filtered,e,t,r,i)}*[Symbol.iterator](){yield*this.filtered.getQuads()}}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;_N3Parser=_interopRequireDefault(require("./N3Parser"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}class N3StreamParser extends(_readableStream=require("readable-stream")).Transform{constructor(e){super({decodeStrings:!0}),this._readableState.objectMode=!0;const t=new _N3Parser.default(e);let i,r;t.parse({on:(e,t)=>{switch(e){case"data":i=t;break;case"end":r=t}}},(e,t)=>{e&&this.emit("error",e)||t&&this.push(t)},(e,t)=>{this.emit("prefix",e,t)}),this._transform=(e,t,r)=>{i(e),r()},this._flush=e=>{r(),e()}}import(e){return e.on("data",e=>{this.write(e)}),e.on("end",()=>{this.end()}),e.on("error",e=>{this.emit("error",e)}),this}}exports.default=N3StreamParser,Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;_readableStream=require("readable-stream"),_N3Writer=_interopRequireDefault(require("./N3Writer"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}class N3StreamWriter extends _readableStream.Transform{constructor(e){super({encoding:"utf8",writableObjectMode:!0});const i=this._writer=new _N3Writer.default({write:(e,t,r)=>{this.push(e),r&&r()},end:e=>{this.push(null),e&&e()}},e);this._transform=(e,t,r)=>{i.addQuad(e,r)},this._flush=e=>{i.end(e)}}import(e){return e.on("data",e=>{this.write(e)}),e.on("end",()=>{this.end()}),e.on("error",e=>{this.emit("error",e)}),e.on("prefix",(e,t)=>{this._writer.addPrefix(e,t)}),this}}exports.default=N3StreamWriter,Object.defineProperty(exports,"__esModule",{value:!0}),exports.isNamedNode=isNamedNode,exports.isBlankNode=isBlankNode,exports.isLiteral=isLiteral,exports.isVariable=isVariable,exports.isDefaultGraph=isDefaultGraph,exports.inDefaultGraph=inDefaultGraph,exports.prefix=prefix,exports.prefixes=prefixes;_N3DataFactory=_interopRequireDefault(require("./N3DataFactory"));function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}function isNamedNode(e){return!!e&&"NamedNode"===e.termType}function isBlankNode(e){return!!e&&"BlankNode"===e.termType}function isLiteral(e){return!!e&&"Literal"===e.termType}function isVariable(e){return!!e&&"Variable"===e.termType}function isDefaultGraph(e){return!!e&&"DefaultGraph"===e.termType}function inDefaultGraph(e){return isDefaultGraph(e.graph)}function prefix(e,t){return prefixes({"":e},t)("")}function prefixes(e,i){const s=Object.create(null);for(const r in e)t(r,e[r]);function t(e,t){if("string"==typeof t){const r=Object.create(null);s[e]=e=>r[e]||(r[e]=i.namedNode(t+e))}else if(!(e in s))throw new Error("Unknown prefix: "+e);return s[e]}return i=i||_N3DataFactory.default,t}Object.defineProperty(exports,"__esModule",{value:!0}),exports.default=void 0;_IRIs=_interopRequireDefault(require("./IRIs")),_N3DataFactory=_interopRequireWildcard(require("./N3DataFactory")),_N3Util=require("./N3Util");function _getRequireWildcardCache(){if("function"!=typeof WeakMap)return null;var e=new WeakMap;return _getRequireWildcardCache=function(){return e},e}function _interopRequireWildcard(e){if(e&&e.__esModule)return e;if(null===e||"object"!=typeof e&&"function"!=typeof e)return{default:e};var t=_getRequireWildcardCache();if(t&&t.has(e))return t.get(e);var r,i,s={},a=Object.defineProperty&&Object.getOwnPropertyDescriptor;for(r in e)Object.prototype.hasOwnProperty.call(e,r)&&((i=a?Object.getOwnPropertyDescriptor(e,r):null)&&(i.get||i.set)?Object.defineProperty(s,r,i):s[r]=e[r]);return s.default=e,t&&t.set(e,s),s}function _interopRequireDefault(e){return e&&e.__esModule?e:{default:e}}const DEFAULTGRAPH=_N3DataFactory.default.defaultGraph(),{rdf,xsd}=_IRIs.default,escape=/["\\\t\n\r\b\f\u0000-\u0019\ud800-\udbff]/,escapeAll=/["\\\t\n\r\b\f\u0000-\u0019]|[\ud800-\udbff][\udc00-\udfff]/g,escapedCharacters={"\\":"\\\\",'"':'\\"',"\t":"\\t","\n":"\\n","\r":"\\r","\b":"\\b","\f":"\\f"};class SerializedTerm extends _N3DataFactory.Term{equals(){return!1}}class N3Writer{constructor(e,t){if(this._prefixRegex=/$0^/,e&&"function"!=typeof e.write&&(t=e,e=null),this._lists=(t=t||{}).lists,e)this._outputStream=e,this._endStream=void 0===t.end||!!t.end;else{let i="";this._outputStream={write(e,t,r){i+=e,r&&r()},end:e=>{e&&e(null,i)}},this._endStream=!0}this._subject=null,/triple|quad/i.test(t.format)?(this._lineMode=!0,this._writeQuad=this._writeQuadLine):(this._lineMode=!1,this._graph=DEFAULTGRAPH,this._prefixIRIs=Object.create(null),t.prefixes&&this.addPrefixes(t.prefixes),t.baseIRI&&(this._baseMatcher=new RegExp("^"+escapeRegex(t.baseIRI)+(t.baseIRI.endsWith("/")?"":"[#?]")),this._baseLength=t.baseIRI.length))}get _inDefaultGraph(){return DEFAULTGRAPH.equals(this._graph)}_write(e,t){this._outputStream.write(e,"utf8",t)}_writeQuad(e,t,r,i,s){try{i.equals(this._graph)||(this._write((null===this._subject?"":this._inDefaultGraph?".\n":"\n}\n")+(DEFAULTGRAPH.equals(i)?"":this._encodeIriOrBlank(i)+` {
`)),this._graph=i,this._subject=null),e.equals(this._subject)?t.equals(this._predicate)?this._write(", "+this._encodeObject(r),s):this._write(`;
    ${this._encodePredicate(this._predicate=t)} `+this._encodeObject(r),s):this._write((null===this._subject?"":".\n")+this._encodeSubject(this._subject=e)+` ${this._encodePredicate(this._predicate=t)} `+this._encodeObject(r),s)}catch(e){s&&s(e)}}_writeQuadLine(e,t,r,i,s){delete this._prefixMatch,this._write(this.quadToString(e,t,r,i),s)}quadToString(e,t,r,i){return`${this._encodeSubject(e)} ${this._encodeIriOrBlank(t)} `+this._encodeObject(r)+(i&&i.value?` ${this._encodeIriOrBlank(i)} .
`:" .\n")}quadsToString(e){return e.map(e=>this.quadToString(e.subject,e.predicate,e.object,e.graph)).join("")}_encodeSubject(e){return"Quad"===e.termType?this._encodeQuad(e):this._encodeIriOrBlank(e)}_encodeIriOrBlank(e){if("NamedNode"!==e.termType)return"id"in(e=this._lists&&e.value in this._lists?this.list(this._lists[e.value]):e)?e.id:"_:"+e.value;let t=e.value;this._baseMatcher&&this._baseMatcher.test(t)&&(t=t.substr(this._baseLength)),escape.test(t)&&(t=t.replace(escapeAll,characterReplacer));e=this._prefixRegex.exec(t);return e?e[1]?this._prefixIRIs[e[1]]+e[2]:t:`<${t}>`}_encodeLiteral(e){let t=e.value;if(escape.test(t)&&(t=t.replace(escapeAll,characterReplacer)),e.language)return`"${t}"@`+e.language;if(this._lineMode){if(e.datatype.value===xsd.string)return`"${t}"`}else switch(e.datatype.value){case xsd.string:return`"${t}"`;case xsd.boolean:if("true"===t||"false"===t)return t;break;case xsd.integer:if(/^[+-]?\d+$/.test(t))return t;break;case xsd.decimal:if(/^[+-]?\d*\.\d+$/.test(t))return t;break;case xsd.double:if(/^[+-]?(?:\d+\.\d*|\.?\d+)[eE][+-]?\d+$/.test(t))return t}return`"${t}"^^`+this._encodeIriOrBlank(e.datatype)}_encodePredicate(e){return e.value===rdf.type?"a":this._encodeIriOrBlank(e)}_encodeObject(e){switch(e.termType){case"Quad":return this._encodeQuad(e);case"Literal":return this._encodeLiteral(e);default:return this._encodeIriOrBlank(e)}}_encodeQuad({subject:e,predicate:t,object:r,graph:i}){return`<<${this._encodeSubject(e)} ${this._encodePredicate(t)} ${this._encodeObject(r)}${(0,_N3Util.isDefaultGraph)(i)?"":" "+this._encodeIriOrBlank(i)}>>`}_blockedWrite(){throw new Error("Cannot write because the writer has been closed.")}addQuad(e,t,r,i,s){void 0===r?this._writeQuad(e.subject,e.predicate,e.object,e.graph,t):"function"==typeof i?this._writeQuad(e,t,r,DEFAULTGRAPH,i):this._writeQuad(e,t,r,i||DEFAULTGRAPH,s)}addQuads(t){for(let e=0;e<t.length;e++)this.addQuad(t[e])}addPrefix(e,t,r){const i={};i[e]=t,this.addPrefixes(i,r)}addPrefixes(t,e){if(!this._prefixIRIs)return e&&e();let r=!1;for(var i in t){let e=t[i];"string"!=typeof e&&(e=e.value),r=!0,null!==this._subject&&(this._write(this._inDefaultGraph?".\n":"\n}\n"),this._subject=null,this._graph=""),this._prefixIRIs[e]=i+=":",this._write(`@prefix ${i} <${e}>.
`)}if(r){let e="",t="";for(const s in this._prefixIRIs)e+=e?"|"+s:s,t+=(t?"|":"")+this._prefixIRIs[s];e=escapeRegex(e,/[\]\/\(\)\*\+\?\.\\\$]/g,"\\$&"),this._prefixRegex=new RegExp(`^(?:${t})[^/]*$|`+`^(${e})([a-zA-Z][\\-_a-zA-Z0-9]*)$`)}this._write(r?"\n":"",e)}blank(r,e){let i=r,s,a;switch(void 0===r?i=[]:r.termType?i=[{predicate:r,object:e}]:"length"in r||(i=[r]),a=i.length){case 0:return new SerializedTerm("[]");case 1:if(s=i[0],!(s.object instanceof SerializedTerm))return new SerializedTerm(`[ ${this._encodePredicate(s.predicate)} ${this._encodeObject(s.object)} ]`);default:let t="[";for(let e=0;e<a;e++)s=i[e],s.predicate.equals(r)?t+=", "+this._encodeObject(s.object):(t+=(e?";\n  ":"\n  ")+this._encodePredicate(s.predicate)+" "+this._encodeObject(s.object),r=s.predicate);return new SerializedTerm(t+`
]`)}}list(t){const r=t&&t.length||0,i=new Array(r);for(let e=0;e<r;e++)i[e]=this._encodeObject(t[e]);return new SerializedTerm(`(${i.join(" ")})`)}end(r){null!==this._subject&&(this._write(this._inDefaultGraph?".\n":"\n}\n"),this._subject=null),this._write=this._blockedWrite;let i=r&&((e,t)=>{i=null,r(e,t)});if(this._endStream)try{return this._outputStream.end(i)}catch(e){}i&&i()}}function characterReplacer(e){let t=escapedCharacters[e];return void 0===t&&(t=1===e.length?(t=e.charCodeAt(0).toString(16),"\\u0000".substr(0,6-t.length)+t):(t=(1024*(e.charCodeAt(0)-55296)+e.charCodeAt(1)+9216).toString(16),"\\U00000000".substr(0,10-t.length)+t)),t}function escapeRegex(e){return e.replace(/[\]\/\(\)\*\+\?\.\\\$]/g,"\\$&")}exports.default=N3Writer;
//# sourceMappingURL=rdflib.min.js.map